package com.android.tcplugins.FileSystem;

import com.android.tcplugins.FileSystem.PluginItem;
import com.android.tcplugins.FileSystem.IRemoteProgressCallback;
import com.android.tcplugins.FileSystem.IRemoteDialogCallback;
import com.android.tcplugins.FileSystem.IRemoteCopyCallback;
import android.graphics.Bitmap;

interface IPluginFunctions {
	int getSupportedFunctions();
	List<PluginItem> getDirectoryList(String dirName);	
	boolean deleteFile(String fileName);
	boolean removeDir(String dirName);
	boolean makeDir(String dirName);
	int getFile(String fullSrc,inout String[] fullTrg,int copyFlags,long size,long lastWriteTime);
	int putFile(String fullSrc,String fullTrg,int copyFlags);
	int renMovFile(String fullSrc, String fullTrg, boolean move,
					boolean overwrite, long size,long lastWriteTime);
	int execute(inout String[] fullPath,String verb);
	Bitmap getBitmap(String fileName);
	String getLocalFileName(String fullSrc);
	void setAbortFlag(String dirName,boolean abort);
	void registerCallbacks(IRemoteProgressCallback cb,IRemoteDialogCallback cb2);
	String disconnect(String rootName);
	void statusInfo(String dirName, int infoStartEnd, int infoOperation);
	IRemoteCopyCallback getFileCallback(String fullSrc);
	int putFileFromCallback(in IRemoteCopyCallback srcCallback, String fullTrg, int copyFlags, long size, long lastWriteTime);
	String getModifiedLocalName(String fullRemote,String localName);
}