package com.android.tcplugins.FileSystem;

import android.os.Parcel;
import android.os.Parcelable;
import com.ghisler.tcplugins.sample.R;

public class PluginItem implements Parcelable, Comparable<PluginItem> {
	public String name=null;
	public String description=null;
	public boolean directory=false;
	public long length=-1;
	public long lastModified=-1;
	public int iconFlags=0;  // 0=default, 1=call extract
	public int attr=0;
	public int unixAttr=0;
	
	 public static final Parcelable.Creator<PluginItem> CREATOR = new Parcelable.Creator<PluginItem>() {
	        public PluginItem createFromParcel(Parcel in) {
	            return new PluginItem(in);
	        }

	        public PluginItem[] newArray(int size) {
	            return new PluginItem[size];
	        }
	    };
	
	public PluginItem(){
	}
	private PluginItem(Parcel in) {
		readFromParcel(in);
	}
	@Override
	public int describeContents() {
		// TODO Auto-generated method stub
		return 0;
	}
	@Override
	public void writeToParcel(Parcel dest, int flags) {
		dest.writeString(name);
		dest.writeString(description);
		dest.writeByte((byte)(directory?1:0));
		dest.writeLong(length);
		dest.writeLong(lastModified);
		dest.writeInt(iconFlags);		
		dest.writeInt(attr);		
		dest.writeInt(unixAttr);		
	}
	public void readFromParcel(Parcel in) {
		name=in.readString();
		description=in.readString();
		directory=0!=in.readByte();
		length=in.readLong();
		lastModified=in.readLong();
		iconFlags=in.readInt();
		attr=in.readInt();
		unixAttr=in.readInt();
	}
	@Override
	public int compareTo(PluginItem another) {
		return name.compareToIgnoreCase(another.name);
	}
}
