package com.android.tcplugins.FileSystem;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import com.ghisler.tcplugins.sample.R;

import android.app.NotificationManager;
import android.app.Service;
import android.content.Intent;
import android.graphics.Bitmap;
import android.os.IBinder;
import android.os.RemoteException;
import android.widget.Toast;

public class PluginService extends Service {
    NotificationManager mNM;
    PluginFunctions pluginFunctions=null; 

	@Override
	public IBinder onBind(Intent intent) {
        String s1=IPluginFunctions.class.getName();
        String s2=intent.getAction();
        int i1=s1.lastIndexOf('.');
        int i2=s2.lastIndexOf('.');
        // do NOT check full name here, it will differ, otherwise there could be only one plugin!
        if (i1>0 && i2>0 && s1.substring(i1).equals(s2.substring(i2))) {
        	if (pluginFunctions==null)
        		pluginFunctions=new PluginFunctions(this);
            return pluginFunctions;
        }
        return null;
	}

    @Override
    public int onStartCommand(Intent intent, int flags, int startId) 
    {
        // We want this service to continue running until it is explicitly
        // stopped, so return sticky.
        return START_STICKY;
    }
	
    @Override
    public void onCreate() {
        mNM = (NotificationManager)getSystemService(NOTIFICATION_SERVICE);
        // Display a notification about us starting.
        Toast.makeText(this, R.string.remote_service_started, Toast.LENGTH_SHORT).show();
   } 
    @Override
    public void onDestroy() {
        // Cancel the persistent notification.
        mNM.cancel(R.string.remote_service_started);

        // Tell the user we stopped.
        Toast.makeText(this, R.string.remote_service_stopped, Toast.LENGTH_SHORT).show();
        
        // Unregister all callbacks.
        // mCallbacks.kill();
        
    } 	

}
